import type { CompactAndOp } from '../codec/compact/types';
import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import type { AbstractPredicateOp } from './AbstractPredicateOp';
import type { OperationAnd } from '../types';
import { OPCODE } from '../constants';
import { type Path } from '@jsonjoy.com/json-pointer';
import type { AbstractOp } from './AbstractOp';
import type { IMessagePackEncoder } from '@jsonjoy.com/json-pack/lib/msgpack';
/**
 * @category JSON Predicate
 */
export declare class OpAnd extends AbstractSecondOrderPredicateOp<'and'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    op(): "and";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationAnd;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactAndOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
