"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Chrome = void 0;
const tslib_1 = require("tslib");
// biome-ignore lint: React is used for JSX
const React = tslib_1.__importStar(require("react"));
const nano_theme_1 = require("nano-theme");
const TopToolbar_1 = require("../TopToolbar");
const context_1 = require("../context");
const blockClass = (0, nano_theme_1.rule)({
    bg: 'white',
    bxz: 'border-box',
    bdrad: '16px',
    pad: '24px 32px',
    lh: '1.7em',
    bxsh: '0 1px 8px #00000008,0 1px 4px #0000000a,0 4px 10px #0000000f',
    '&:hover': {
        bxsh: '0 1px 8px #00000008,0 1px 4px #0000000a,0 4px 10px #0000000f,0 0 3px #0000001f',
    },
});
const Chrome = ({ children }) => {
    const { ctx } = (0, context_1.usePlugin)();
    return (React.createElement("div", { className: blockClass },
        !!ctx && React.createElement(TopToolbar_1.TopToolbar, { ctx: ctx }),
        children));
};
exports.Chrome = Chrome;
