import type { CompactMoreOp } from '../codec/compact/types';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import type { OperationMore } from '../types';
import { type Path } from '@jsonjoy.com/json-pointer';
import { OPCODE } from '../constants';
import type { AbstractOp } from './AbstractOp';
import type { IMessagePackEncoder } from '@jsonjoy.com/json-pack/lib/msgpack';
/**
 * @category JSON Predicate
 */
export declare class OpMore extends AbstractPredicateOp<'more'> {
    readonly value: number;
    constructor(path: Path, value: number);
    op(): "more";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationMore;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactMoreOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
